// Implementation file for parser generated by fsyacc
#light "off"
#nowarn "64";; // turn off warnings that type variables used in production annotations are instantiated to concrete type
open Microsoft.FSharp.Text.Lexing
open Microsoft.FSharp.Text.Parsing.ParseHelpers
# 6 "hog_parser.mly"

open Hog
open Type

type validators = Universal | Demiranda | ReverseDemiranda;;
let parsed_validator = ref Universal;;
let parsed_nonterminals = ref [];;
let parsed_terminals = ref [];;
let parsed_rules = ref [];;
let parsed_name  = ref "";;


let section_name_present = ref false;;
let section_nonterminals_present = ref false;;
let section_validator_present = ref false;;
let section_terminals_present = ref false;;
let section_rules_present = ref false;;

# 25 "hog_parser.ml"
// This type is the type of tokens accepted by the parser
type token = 
  | ATOM of (string)
  | NONE
  | DEMIRANDA
  | REVERSE_DEMIRANDA
  | SEC_NAME
  | SEC_VALIDATOR
  | SEC_TERMINALS
  | SEC_NONTERMINALS
  | SEC_RULES
  | COMMA
  | COLON
  | SEMICOLON
  | LCB
  | RCB
  | LP
  | RP
  | EQUAL
  | ARROW
  | BADTOK
  | EOF
// This type is used to give symbolic names to token indexes, useful for error messages
type tokenId = 
    | TOKEN_ATOM
    | TOKEN_NONE
    | TOKEN_DEMIRANDA
    | TOKEN_REVERSE_DEMIRANDA
    | TOKEN_SEC_NAME
    | TOKEN_SEC_VALIDATOR
    | TOKEN_SEC_TERMINALS
    | TOKEN_SEC_NONTERMINALS
    | TOKEN_SEC_RULES
    | TOKEN_COMMA
    | TOKEN_COLON
    | TOKEN_SEMICOLON
    | TOKEN_LCB
    | TOKEN_RCB
    | TOKEN_LP
    | TOKEN_RP
    | TOKEN_EQUAL
    | TOKEN_ARROW
    | TOKEN_BADTOK
    | TOKEN_EOF
    | TOKEN_end_of_input
    | TOKEN_error
// This type is used to give symbolic names to token indexes, useful for error messages
type nonTerminalId = 
    | NONTERM__starthog_specification
    | NONTERM_hog_specification
    | NONTERM_sectionlist
    | NONTERM_section
    | NONTERM_sec_name
    | NONTERM_sec_name_content
    | NONTERM_sec_validator
    | NONTERM_sec_validator_content
    | NONTERM_sec_terminals
    | NONTERM_terminal_list
    | NONTERM_typ
    | NONTERM_sec_nonterminals
    | NONTERM_sec_rules
    | NONTERM_rule_list
    | NONTERM_rule
    | NONTERM_applicative_term
    | NONTERM_terminal_nonterminal
    | NONTERM_application
    | NONTERM_bracketed_application
    | NONTERM_paramlist
    | NONTERM_ident

// This function maps tokens to integers indexes
let tagOfToken (t:token) = 
  match t with
  | ATOM _ -> 0 
  | NONE  -> 1 
  | DEMIRANDA  -> 2 
  | REVERSE_DEMIRANDA  -> 3 
  | SEC_NAME  -> 4 
  | SEC_VALIDATOR  -> 5 
  | SEC_TERMINALS  -> 6 
  | SEC_NONTERMINALS  -> 7 
  | SEC_RULES  -> 8 
  | COMMA  -> 9 
  | COLON  -> 10 
  | SEMICOLON  -> 11 
  | LCB  -> 12 
  | RCB  -> 13 
  | LP  -> 14 
  | RP  -> 15 
  | EQUAL  -> 16 
  | ARROW  -> 17 
  | BADTOK  -> 18 
  | EOF  -> 19 

// This function maps integers indexes to symbolic token ids
let tokenTagToTokenId (tokenIdx:int) = 
  match tokenIdx with
  | 0 -> TOKEN_ATOM 
  | 1 -> TOKEN_NONE 
  | 2 -> TOKEN_DEMIRANDA 
  | 3 -> TOKEN_REVERSE_DEMIRANDA 
  | 4 -> TOKEN_SEC_NAME 
  | 5 -> TOKEN_SEC_VALIDATOR 
  | 6 -> TOKEN_SEC_TERMINALS 
  | 7 -> TOKEN_SEC_NONTERMINALS 
  | 8 -> TOKEN_SEC_RULES 
  | 9 -> TOKEN_COMMA 
  | 10 -> TOKEN_COLON 
  | 11 -> TOKEN_SEMICOLON 
  | 12 -> TOKEN_LCB 
  | 13 -> TOKEN_RCB 
  | 14 -> TOKEN_LP 
  | 15 -> TOKEN_RP 
  | 16 -> TOKEN_EQUAL 
  | 17 -> TOKEN_ARROW 
  | 18 -> TOKEN_BADTOK 
  | 19 -> TOKEN_EOF 
  | 22 -> TOKEN_end_of_input
  | 20 -> TOKEN_error
  | _ -> failwith "tokenTagToTokenId: bad token"

/// This function maps production indexes returned in syntax errors to strings representing the non terminal that would be produced by that production
let prodIdxToNonTerminal (prodIdx:int) = 
  match prodIdx with
    | 0 -> NONTERM__starthog_specification 
    | 1 -> NONTERM_hog_specification 
    | 2 -> NONTERM_sectionlist 
    | 3 -> NONTERM_sectionlist 
    | 4 -> NONTERM_section 
    | 5 -> NONTERM_section 
    | 6 -> NONTERM_section 
    | 7 -> NONTERM_section 
    | 8 -> NONTERM_section 
    | 9 -> NONTERM_sec_name 
    | 10 -> NONTERM_sec_name_content 
    | 11 -> NONTERM_sec_validator 
    | 12 -> NONTERM_sec_validator_content 
    | 13 -> NONTERM_sec_validator_content 
    | 14 -> NONTERM_sec_validator_content 
    | 15 -> NONTERM_sec_terminals 
    | 16 -> NONTERM_terminal_list 
    | 17 -> NONTERM_terminal_list 
    | 18 -> NONTERM_typ 
    | 19 -> NONTERM_typ 
    | 20 -> NONTERM_typ 
    | 21 -> NONTERM_sec_nonterminals 
    | 22 -> NONTERM_sec_rules 
    | 23 -> NONTERM_rule_list 
    | 24 -> NONTERM_rule_list 
    | 25 -> NONTERM_rule 
    | 26 -> NONTERM_applicative_term 
    | 27 -> NONTERM_applicative_term 
    | 28 -> NONTERM_terminal_nonterminal 
    | 29 -> NONTERM_application 
    | 30 -> NONTERM_application 
    | 31 -> NONTERM_bracketed_application 
    | 32 -> NONTERM_bracketed_application 
    | 33 -> NONTERM_paramlist 
    | 34 -> NONTERM_paramlist 
    | 35 -> NONTERM_ident 
    | _ -> failwith "prodIdxToNonTerminal: bad production index"

let _fsyacc_endOfInputTag = 22 
let _fsyacc_tagOfErrorTerminal = 20

// This function gets the name of a token as a string
let token_to_string (t:token) = 
  match t with 
  | ATOM _ -> "ATOM" 
  | NONE  -> "NONE" 
  | DEMIRANDA  -> "DEMIRANDA" 
  | REVERSE_DEMIRANDA  -> "REVERSE_DEMIRANDA" 
  | SEC_NAME  -> "SEC_NAME" 
  | SEC_VALIDATOR  -> "SEC_VALIDATOR" 
  | SEC_TERMINALS  -> "SEC_TERMINALS" 
  | SEC_NONTERMINALS  -> "SEC_NONTERMINALS" 
  | SEC_RULES  -> "SEC_RULES" 
  | COMMA  -> "COMMA" 
  | COLON  -> "COLON" 
  | SEMICOLON  -> "SEMICOLON" 
  | LCB  -> "LCB" 
  | RCB  -> "RCB" 
  | LP  -> "LP" 
  | RP  -> "RP" 
  | EQUAL  -> "EQUAL" 
  | ARROW  -> "ARROW" 
  | BADTOK  -> "BADTOK" 
  | EOF  -> "EOF" 

// This function gets the data carried by a token as an object
let _fsyacc_dataOfToken (t:token) = 
  match t with 
  | ATOM _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | NONE  -> (null : System.Object) 
  | DEMIRANDA  -> (null : System.Object) 
  | REVERSE_DEMIRANDA  -> (null : System.Object) 
  | SEC_NAME  -> (null : System.Object) 
  | SEC_VALIDATOR  -> (null : System.Object) 
  | SEC_TERMINALS  -> (null : System.Object) 
  | SEC_NONTERMINALS  -> (null : System.Object) 
  | SEC_RULES  -> (null : System.Object) 
  | COMMA  -> (null : System.Object) 
  | COLON  -> (null : System.Object) 
  | SEMICOLON  -> (null : System.Object) 
  | LCB  -> (null : System.Object) 
  | RCB  -> (null : System.Object) 
  | LP  -> (null : System.Object) 
  | RP  -> (null : System.Object) 
  | EQUAL  -> (null : System.Object) 
  | ARROW  -> (null : System.Object) 
  | BADTOK  -> (null : System.Object) 
  | EOF  -> (null : System.Object) 
let _fsyacc_gotos = [| 0us; 65535us; 1us; 65535us; 0us; 1us; 2us; 65535us; 0us; 2us; 3us; 4us; 2us; 65535us; 0us; 3us; 3us; 3us; 2us; 65535us; 0us; 5us; 3us; 5us; 1us; 65535us; 11us; 12us; 2us; 65535us; 0us; 6us; 3us; 6us; 1us; 65535us; 16us; 17us; 2us; 65535us; 0us; 7us; 3us; 7us; 3us; 65535us; 23us; 24us; 29us; 30us; 38us; 39us; 3us; 65535us; 27us; 28us; 32us; 33us; 36us; 35us; 2us; 65535us; 0us; 8us; 3us; 8us; 2us; 65535us; 0us; 9us; 3us; 9us; 2us; 65535us; 42us; 43us; 46us; 47us; 2us; 65535us; 42us; 45us; 46us; 45us; 1us; 65535us; 50us; 51us; 5us; 65535us; 50us; 52us; 53us; 61us; 55us; 61us; 57us; 61us; 59us; 61us; 2us; 65535us; 50us; 53us; 59us; 57us; 5us; 65535us; 50us; 55us; 53us; 58us; 55us; 56us; 57us; 58us; 59us; 55us; 2us; 65535us; 48us; 49us; 62us; 63us; 16us; 65535us; 11us; 14us; 23us; 26us; 27us; 31us; 29us; 26us; 32us; 31us; 36us; 31us; 38us; 26us; 42us; 48us; 46us; 48us; 48us; 62us; 50us; 54us; 53us; 54us; 55us; 54us; 57us; 54us; 59us; 54us; 62us; 62us; |]
let _fsyacc_sparseGotoTableRowOffsets = [|0us; 1us; 3us; 6us; 9us; 12us; 14us; 17us; 19us; 22us; 26us; 30us; 33us; 36us; 39us; 42us; 44us; 50us; 53us; 59us; 62us; |]
let _fsyacc_stateToProdIdxsTableElements = [| 1us; 0us; 1us; 0us; 1us; 1us; 1us; 3us; 1us; 3us; 1us; 4us; 1us; 5us; 1us; 6us; 1us; 7us; 1us; 8us; 1us; 9us; 1us; 9us; 1us; 9us; 1us; 9us; 1us; 10us; 1us; 11us; 1us; 11us; 1us; 11us; 1us; 11us; 1us; 12us; 1us; 13us; 1us; 14us; 1us; 15us; 1us; 15us; 1us; 15us; 1us; 15us; 1us; 17us; 1us; 17us; 2us; 17us; 20us; 1us; 17us; 1us; 17us; 1us; 18us; 1us; 19us; 2us; 19us; 20us; 1us; 19us; 2us; 20us; 20us; 1us; 20us; 1us; 21us; 1us; 21us; 1us; 21us; 1us; 21us; 1us; 22us; 1us; 22us; 1us; 22us; 1us; 22us; 1us; 24us; 1us; 24us; 1us; 24us; 1us; 25us; 1us; 25us; 1us; 25us; 1us; 25us; 2us; 26us; 32us; 2us; 27us; 30us; 1us; 28us; 1us; 29us; 1us; 29us; 2us; 30us; 31us; 1us; 30us; 1us; 31us; 1us; 31us; 1us; 32us; 1us; 34us; 1us; 34us; 1us; 35us; |]
let _fsyacc_stateToProdIdxsTableRowOffsets = [|0us; 2us; 4us; 6us; 8us; 10us; 12us; 14us; 16us; 18us; 20us; 22us; 24us; 26us; 28us; 30us; 32us; 34us; 36us; 38us; 40us; 42us; 44us; 46us; 48us; 50us; 52us; 54us; 56us; 59us; 61us; 63us; 65us; 67us; 70us; 72us; 75us; 77us; 79us; 81us; 83us; 85us; 87us; 89us; 91us; 93us; 95us; 97us; 99us; 101us; 103us; 105us; 107us; 110us; 113us; 115us; 117us; 119us; 122us; 124us; 126us; 128us; 130us; 132us; 134us; |]
let _fsyacc_action_rows = 65
let _fsyacc_actionTableElements = [|5us; 16386us; 4us; 10us; 5us; 15us; 6us; 22us; 7us; 37us; 8us; 41us; 0us; 49152us; 0us; 16385us; 5us; 16386us; 4us; 10us; 5us; 15us; 6us; 22us; 7us; 37us; 8us; 41us; 0us; 16387us; 0us; 16388us; 0us; 16389us; 0us; 16390us; 0us; 16391us; 0us; 16392us; 1us; 32768us; 12us; 11us; 1us; 32768us; 0us; 64us; 1us; 32768us; 13us; 13us; 0us; 16393us; 0us; 16394us; 1us; 32768us; 12us; 16us; 3us; 32768us; 1us; 21us; 2us; 20us; 3us; 19us; 1us; 32768us; 13us; 18us; 0us; 16395us; 0us; 16396us; 0us; 16397us; 0us; 16398us; 1us; 32768us; 12us; 23us; 1us; 16400us; 0us; 64us; 1us; 32768us; 13us; 25us; 0us; 16399us; 1us; 32768us; 10us; 27us; 2us; 32768us; 0us; 64us; 14us; 32us; 2us; 32768us; 11us; 29us; 17us; 36us; 1us; 16400us; 0us; 64us; 0us; 16401us; 0us; 16402us; 2us; 32768us; 0us; 64us; 14us; 32us; 2us; 32768us; 15us; 34us; 17us; 36us; 0us; 16403us; 1us; 16404us; 17us; 36us; 2us; 32768us; 0us; 64us; 14us; 32us; 1us; 32768us; 12us; 38us; 1us; 16400us; 0us; 64us; 1us; 32768us; 13us; 40us; 0us; 16405us; 1us; 32768us; 12us; 42us; 1us; 16407us; 0us; 64us; 1us; 32768us; 13us; 44us; 0us; 16406us; 1us; 32768us; 11us; 46us; 1us; 16407us; 0us; 64us; 0us; 16408us; 1us; 16417us; 0us; 64us; 1us; 32768us; 16us; 50us; 2us; 32768us; 0us; 64us; 14us; 59us; 0us; 16409us; 2us; 16410us; 0us; 16416us; 14us; 16416us; 2us; 16411us; 0us; 64us; 14us; 59us; 0us; 16412us; 2us; 32768us; 0us; 64us; 14us; 59us; 0us; 16413us; 3us; 32768us; 0us; 64us; 14us; 59us; 15us; 60us; 0us; 16414us; 2us; 32768us; 0us; 64us; 14us; 59us; 0us; 16415us; 0us; 16416us; 1us; 16417us; 0us; 64us; 0us; 16418us; 0us; 16419us; |]
let _fsyacc_actionTableRowOffsets = [|0us; 6us; 7us; 8us; 14us; 15us; 16us; 17us; 18us; 19us; 20us; 22us; 24us; 26us; 27us; 28us; 30us; 34us; 36us; 37us; 38us; 39us; 40us; 42us; 44us; 46us; 47us; 49us; 52us; 55us; 57us; 58us; 59us; 62us; 65us; 66us; 68us; 71us; 73us; 75us; 77us; 78us; 80us; 82us; 84us; 85us; 87us; 89us; 90us; 92us; 94us; 97us; 98us; 101us; 104us; 105us; 108us; 109us; 113us; 114us; 117us; 118us; 119us; 121us; 122us; |]
let _fsyacc_reductionSymbolCounts = [|1us; 1us; 0us; 2us; 1us; 1us; 1us; 1us; 1us; 4us; 1us; 4us; 1us; 1us; 1us; 4us; 0us; 5us; 1us; 3us; 3us; 4us; 4us; 0us; 3us; 4us; 1us; 1us; 1us; 2us; 2us; 3us; 1us; 0us; 2us; 1us; |]
let _fsyacc_productionToNonTerminalTable = [|0us; 1us; 2us; 2us; 3us; 3us; 3us; 3us; 3us; 4us; 5us; 6us; 7us; 7us; 7us; 8us; 9us; 9us; 10us; 10us; 10us; 11us; 12us; 13us; 13us; 14us; 15us; 15us; 16us; 17us; 17us; 18us; 18us; 19us; 19us; 20us; |]
let _fsyacc_immediateActions = [|65535us; 49152us; 16385us; 65535us; 16387us; 16388us; 16389us; 16390us; 16391us; 16392us; 65535us; 65535us; 65535us; 16393us; 16394us; 65535us; 65535us; 65535us; 16395us; 16396us; 16397us; 16398us; 65535us; 65535us; 65535us; 16399us; 65535us; 65535us; 65535us; 65535us; 16401us; 16402us; 65535us; 65535us; 16403us; 65535us; 65535us; 65535us; 65535us; 65535us; 16405us; 65535us; 65535us; 65535us; 16406us; 65535us; 65535us; 16408us; 65535us; 65535us; 65535us; 16409us; 65535us; 65535us; 16412us; 65535us; 16413us; 65535us; 16414us; 65535us; 16415us; 16416us; 65535us; 16418us; 16419us; |]
let _fsyacc_reductions ()  =    [| 
# 249 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Hog.recscheme)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Microsoft.FSharp.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_starthog_specification));
# 258 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'sectionlist)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 49 "hog_parser.mly"
                      if not !section_name_present 
                     																   || not !section_validator_present 
                     																   || not !section_terminals_present 
                     																   || not !section_nonterminals_present 
                     																   || not !section_rules_present 
                     																   then
                     																	   raise Parsing.MissingSection
                     																   else
                      																	   { nonterminals = !parsed_nonterminals;
                     																		sigma = !parsed_terminals;
                     																		rules = !parsed_rules;        
                     																		rs_path_validator = match !parsed_validator with
                     																								  Universal ->  Hog.default_validator
                     																								| Demiranda -> Hog.demiranda_validator
                     																								| ReverseDemiranda -> Hog.reverse_demiranda_validator
                     																	   }
                     																
                   )
# 49 "hog_parser.mly"
                 : Hog.recscheme));
# 285 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 68 "hog_parser.mly"
                      
                   )
# 68 "hog_parser.mly"
                 : 'sectionlist));
# 295 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'section)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'sectionlist)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 69 "hog_parser.mly"
                      
                   )
# 69 "hog_parser.mly"
                 : 'sectionlist));
# 307 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'sec_name)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 72 "hog_parser.mly"
                      section_name_present := true 
                   )
# 72 "hog_parser.mly"
                 : 'section));
# 318 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'sec_validator)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 73 "hog_parser.mly"
                      section_validator_present := true 
                   )
# 73 "hog_parser.mly"
                 : 'section));
# 329 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'sec_terminals)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 74 "hog_parser.mly"
                      section_terminals_present := true 
                   )
# 74 "hog_parser.mly"
                 : 'section));
# 340 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'sec_nonterminals)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 75 "hog_parser.mly"
                      section_nonterminals_present := true 
                   )
# 75 "hog_parser.mly"
                 : 'section));
# 351 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'sec_rules)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 76 "hog_parser.mly"
                      section_rules_present := true 
                   )
# 76 "hog_parser.mly"
                 : 'section));
# 362 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'sec_name_content)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 80 "hog_parser.mly"
                      
                   )
# 80 "hog_parser.mly"
                 : 'sec_name));
# 373 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 82 "hog_parser.mly"
                      parsed_name := _1 
                   )
# 82 "hog_parser.mly"
                 : 'sec_name_content));
# 384 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'sec_validator_content)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 85 "hog_parser.mly"
                      
                   )
# 85 "hog_parser.mly"
                 : 'sec_validator));
# 395 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 87 "hog_parser.mly"
                      parsed_validator := ReverseDemiranda 
                   )
# 87 "hog_parser.mly"
                 : 'sec_validator_content));
# 405 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 88 "hog_parser.mly"
                      parsed_validator := Demiranda 
                   )
# 88 "hog_parser.mly"
                 : 'sec_validator_content));
# 415 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 89 "hog_parser.mly"
                      parsed_validator := Universal 
                   )
# 89 "hog_parser.mly"
                 : 'sec_validator_content));
# 425 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'terminal_list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 93 "hog_parser.mly"
                      parsed_terminals := _3 
                   )
# 93 "hog_parser.mly"
                 : 'sec_terminals));
# 436 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 97 "hog_parser.mly"
                      [] 
                   )
# 97 "hog_parser.mly"
                 : 'terminal_list));
# 446 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typ)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'terminal_list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 98 "hog_parser.mly"
                      (_1,_3)::_5 
                   )
# 98 "hog_parser.mly"
                 : 'terminal_list));
# 459 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 103 "hog_parser.mly"
                      if _1 = "o" then Gr else failwith "Invalid type!" 
                   )
# 103 "hog_parser.mly"
                 : 'typ));
# 470 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typ)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 104 "hog_parser.mly"
                      _2 
                   )
# 104 "hog_parser.mly"
                 : 'typ));
# 481 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typ)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typ)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 105 "hog_parser.mly"
                      Ar(_1,_3) 
                   )
# 105 "hog_parser.mly"
                 : 'typ));
# 493 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'terminal_list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 113 "hog_parser.mly"
                      parsed_nonterminals := _3 
                   )
# 113 "hog_parser.mly"
                 : 'sec_nonterminals));
# 504 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rule_list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 116 "hog_parser.mly"
                      parsed_rules := _3 
                   )
# 116 "hog_parser.mly"
                 : 'sec_rules));
# 515 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 118 "hog_parser.mly"
                      [] 
                   )
# 118 "hog_parser.mly"
                 : 'rule_list));
# 525 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'rule)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'rule_list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 119 "hog_parser.mly"
                      _1::_3 
                   )
# 119 "hog_parser.mly"
                 : 'rule_list));
# 537 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'paramlist)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'applicative_term)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 121 "hog_parser.mly"
                      _1,_2,_4 
                   )
# 121 "hog_parser.mly"
                 : 'rule));
# 550 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'terminal_nonterminal)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 125 "hog_parser.mly"
                      _1 
                   )
# 125 "hog_parser.mly"
                 : 'applicative_term));
# 561 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'application)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 126 "hog_parser.mly"
                      _1 
                   )
# 126 "hog_parser.mly"
                 : 'applicative_term));
# 572 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 129 "hog_parser.mly"
                      if List.exists (function a,_ -> a = _1) !parsed_nonterminals then
                     																	Nt(_1)
                     																  else if List.exists (function a,_ -> a = _1) !parsed_terminals then
                     																	Tm(_1)
                     																  else
                     																	Var(_1)
                     																
                   )
# 129 "hog_parser.mly"
                 : 'terminal_nonterminal));
# 589 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'bracketed_application)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'bracketed_application)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 138 "hog_parser.mly"
                      App(_1,_2) 
                   )
# 138 "hog_parser.mly"
                 : 'application));
# 601 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'application)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'bracketed_application)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 139 "hog_parser.mly"
                      App(_1,_2) 
                   )
# 139 "hog_parser.mly"
                 : 'application));
# 613 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'application)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 143 "hog_parser.mly"
                      _2 
                   )
# 143 "hog_parser.mly"
                 : 'bracketed_application));
# 624 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'terminal_nonterminal)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 144 "hog_parser.mly"
                      _1 
                   )
# 144 "hog_parser.mly"
                 : 'bracketed_application));
# 635 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 151 "hog_parser.mly"
                      [] 
                   )
# 151 "hog_parser.mly"
                 : 'paramlist));
# 645 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'paramlist)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 152 "hog_parser.mly"
                      _1::_2 
                   )
# 152 "hog_parser.mly"
                 : 'paramlist));
# 657 "hog_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 155 "hog_parser.mly"
                      _1 
                   )
# 155 "hog_parser.mly"
                 : 'ident));
|]
# 669 "hog_parser.ml"
let tables () : Microsoft.FSharp.Text.Parsing.Tables<_> = 
  { reductions= _fsyacc_reductions ();
    endOfInputTag = _fsyacc_endOfInputTag;
    tagOfToken = tagOfToken;
    dataOfToken = _fsyacc_dataOfToken; 
    actionTableElements = _fsyacc_actionTableElements;
    actionTableRowOffsets = _fsyacc_actionTableRowOffsets;
    stateToProdIdxsTableElements = _fsyacc_stateToProdIdxsTableElements;
    stateToProdIdxsTableRowOffsets = _fsyacc_stateToProdIdxsTableRowOffsets;
    reductionSymbolCounts = _fsyacc_reductionSymbolCounts;
    immediateActions = _fsyacc_immediateActions;
    gotos = _fsyacc_gotos;
    sparseGotoTableRowOffsets = _fsyacc_sparseGotoTableRowOffsets;
    tagOfErrorTerminal = _fsyacc_tagOfErrorTerminal;
    parseError = (fun (ctxt:Microsoft.FSharp.Text.Parsing.ParseErrorContext<_>) -> 
                              match parse_error_rich with 
                              | Some f -> f ctxt
                              | None -> parse_error ctxt.Message);
    numTerminals = 23;
    productionToNonTerminalTable = _fsyacc_productionToNonTerminalTable  }
let engine lexer lexbuf startState = (tables ()).Interpret(lexer, lexbuf, startState)
let hog_specification lexer lexbuf : Hog.recscheme =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 0))
