// Implementation file for parser generated by fsyacc
#light "off"
#nowarn "64";; // turn off warnings that type variables used in production annotations are instantiated to concrete type
open Microsoft.FSharp.Text.Lexing
open Microsoft.FSharp.Text.Parsing.ParseHelpers
# 6 "ml_parser.mly"
 
//open Coreml;;
open Type;;

# 11 "ml_parser.ml"
// This type is the type of tokens accepted by the parser
type token = 
  | ANYINT
  | COMMA
  | SEMISEMI
  | COLON
  | SEMICOLON
  | SUCC
  | PRED
  | TRUE
  | FALSE
  | ADDOP
  | IF
  | THEN
  | ELSE
  | EQUAL
  | IN
  | ARROW
  | AT
  | FUN
  | LET
  | AND
  | REC
  | VDASH
  | DOT
  | LP
  | RP
  | BADTOK
  | EOF
  | NUMBER of (int)
  | IDENT of (string)
// This type is used to give symbolic names to token indexes, useful for error messages
type tokenId = 
    | TOKEN_ANYINT
    | TOKEN_COMMA
    | TOKEN_SEMISEMI
    | TOKEN_COLON
    | TOKEN_SEMICOLON
    | TOKEN_SUCC
    | TOKEN_PRED
    | TOKEN_TRUE
    | TOKEN_FALSE
    | TOKEN_ADDOP
    | TOKEN_IF
    | TOKEN_THEN
    | TOKEN_ELSE
    | TOKEN_EQUAL
    | TOKEN_IN
    | TOKEN_ARROW
    | TOKEN_AT
    | TOKEN_FUN
    | TOKEN_LET
    | TOKEN_AND
    | TOKEN_REC
    | TOKEN_VDASH
    | TOKEN_DOT
    | TOKEN_LP
    | TOKEN_RP
    | TOKEN_BADTOK
    | TOKEN_EOF
    | TOKEN_NUMBER
    | TOKEN_IDENT
    | TOKEN_end_of_input
    | TOKEN_error
// This type is used to give symbolic names to token indexes, useful for error messages
type nonTerminalId = 
    | NONTERM__startterm_in_context
    | NONTERM_term_in_context
    | NONTERM_context
    | NONTERM_typ
    | NONTERM_term
    | NONTERM_expression
    | NONTERM_ifthenelse
    | NONTERM_condition
    | NONTERM_boolean
    | NONTERM_integer
    | NONTERM_declaration
    | NONTERM_decl_list_next
    | NONTERM_recdecl_list_next
    | NONTERM_application
    | NONTERM_operand
    | NONTERM_operator
    | NONTERM_abstraction
    | NONTERM_ident_list
    | NONTERM_variable

// This function maps tokens to integers indexes
let tagOfToken (t:token) = 
  match t with
  | ANYINT  -> 0 
  | COMMA  -> 1 
  | SEMISEMI  -> 2 
  | COLON  -> 3 
  | SEMICOLON  -> 4 
  | SUCC  -> 5 
  | PRED  -> 6 
  | TRUE  -> 7 
  | FALSE  -> 8 
  | ADDOP  -> 9 
  | IF  -> 10 
  | THEN  -> 11 
  | ELSE  -> 12 
  | EQUAL  -> 13 
  | IN  -> 14 
  | ARROW  -> 15 
  | AT  -> 16 
  | FUN  -> 17 
  | LET  -> 18 
  | AND  -> 19 
  | REC  -> 20 
  | VDASH  -> 21 
  | DOT  -> 22 
  | LP  -> 23 
  | RP  -> 24 
  | BADTOK  -> 25 
  | EOF  -> 26 
  | NUMBER _ -> 27 
  | IDENT _ -> 28 

// This function maps integers indexes to symbolic token ids
let tokenTagToTokenId (tokenIdx:int) = 
  match tokenIdx with
  | 0 -> TOKEN_ANYINT 
  | 1 -> TOKEN_COMMA 
  | 2 -> TOKEN_SEMISEMI 
  | 3 -> TOKEN_COLON 
  | 4 -> TOKEN_SEMICOLON 
  | 5 -> TOKEN_SUCC 
  | 6 -> TOKEN_PRED 
  | 7 -> TOKEN_TRUE 
  | 8 -> TOKEN_FALSE 
  | 9 -> TOKEN_ADDOP 
  | 10 -> TOKEN_IF 
  | 11 -> TOKEN_THEN 
  | 12 -> TOKEN_ELSE 
  | 13 -> TOKEN_EQUAL 
  | 14 -> TOKEN_IN 
  | 15 -> TOKEN_ARROW 
  | 16 -> TOKEN_AT 
  | 17 -> TOKEN_FUN 
  | 18 -> TOKEN_LET 
  | 19 -> TOKEN_AND 
  | 20 -> TOKEN_REC 
  | 21 -> TOKEN_VDASH 
  | 22 -> TOKEN_DOT 
  | 23 -> TOKEN_LP 
  | 24 -> TOKEN_RP 
  | 25 -> TOKEN_BADTOK 
  | 26 -> TOKEN_EOF 
  | 27 -> TOKEN_NUMBER 
  | 28 -> TOKEN_IDENT 
  | 31 -> TOKEN_end_of_input
  | 29 -> TOKEN_error
  | _ -> failwith "tokenTagToTokenId: bad token"

/// This function maps production indexes returned in syntax errors to strings representing the non terminal that would be produced by that production
let prodIdxToNonTerminal (prodIdx:int) = 
  match prodIdx with
    | 0 -> NONTERM__startterm_in_context 
    | 1 -> NONTERM_term_in_context 
    | 2 -> NONTERM_context 
    | 3 -> NONTERM_context 
    | 4 -> NONTERM_context 
    | 5 -> NONTERM_typ 
    | 6 -> NONTERM_typ 
    | 7 -> NONTERM_typ 
    | 8 -> NONTERM_term 
    | 9 -> NONTERM_expression 
    | 10 -> NONTERM_expression 
    | 11 -> NONTERM_expression 
    | 12 -> NONTERM_expression 
    | 13 -> NONTERM_expression 
    | 14 -> NONTERM_expression 
    | 15 -> NONTERM_expression 
    | 16 -> NONTERM_expression 
    | 17 -> NONTERM_ifthenelse 
    | 18 -> NONTERM_condition 
    | 19 -> NONTERM_boolean 
    | 20 -> NONTERM_boolean 
    | 21 -> NONTERM_integer 
    | 22 -> NONTERM_declaration 
    | 23 -> NONTERM_declaration 
    | 24 -> NONTERM_decl_list_next 
    | 25 -> NONTERM_decl_list_next 
    | 26 -> NONTERM_recdecl_list_next 
    | 27 -> NONTERM_application 
    | 28 -> NONTERM_application 
    | 29 -> NONTERM_operand 
    | 30 -> NONTERM_operand 
    | 31 -> NONTERM_operand 
    | 32 -> NONTERM_operand 
    | 33 -> NONTERM_operand 
    | 34 -> NONTERM_operand 
    | 35 -> NONTERM_operator 
    | 36 -> NONTERM_operator 
    | 37 -> NONTERM_abstraction 
    | 38 -> NONTERM_ident_list 
    | 39 -> NONTERM_ident_list 
    | 40 -> NONTERM_variable 
    | _ -> failwith "prodIdxToNonTerminal: bad production index"

let _fsyacc_endOfInputTag = 31 
let _fsyacc_tagOfErrorTerminal = 29

// This function gets the name of a token as a string
let token_to_string (t:token) = 
  match t with 
  | ANYINT  -> "ANYINT" 
  | COMMA  -> "COMMA" 
  | SEMISEMI  -> "SEMISEMI" 
  | COLON  -> "COLON" 
  | SEMICOLON  -> "SEMICOLON" 
  | SUCC  -> "SUCC" 
  | PRED  -> "PRED" 
  | TRUE  -> "TRUE" 
  | FALSE  -> "FALSE" 
  | ADDOP  -> "ADDOP" 
  | IF  -> "IF" 
  | THEN  -> "THEN" 
  | ELSE  -> "ELSE" 
  | EQUAL  -> "EQUAL" 
  | IN  -> "IN" 
  | ARROW  -> "ARROW" 
  | AT  -> "AT" 
  | FUN  -> "FUN" 
  | LET  -> "LET" 
  | AND  -> "AND" 
  | REC  -> "REC" 
  | VDASH  -> "VDASH" 
  | DOT  -> "DOT" 
  | LP  -> "LP" 
  | RP  -> "RP" 
  | BADTOK  -> "BADTOK" 
  | EOF  -> "EOF" 
  | NUMBER _ -> "NUMBER" 
  | IDENT _ -> "IDENT" 

// This function gets the data carried by a token as an object
let _fsyacc_dataOfToken (t:token) = 
  match t with 
  | ANYINT  -> (null : System.Object) 
  | COMMA  -> (null : System.Object) 
  | SEMISEMI  -> (null : System.Object) 
  | COLON  -> (null : System.Object) 
  | SEMICOLON  -> (null : System.Object) 
  | SUCC  -> (null : System.Object) 
  | PRED  -> (null : System.Object) 
  | TRUE  -> (null : System.Object) 
  | FALSE  -> (null : System.Object) 
  | ADDOP  -> (null : System.Object) 
  | IF  -> (null : System.Object) 
  | THEN  -> (null : System.Object) 
  | ELSE  -> (null : System.Object) 
  | EQUAL  -> (null : System.Object) 
  | IN  -> (null : System.Object) 
  | ARROW  -> (null : System.Object) 
  | AT  -> (null : System.Object) 
  | FUN  -> (null : System.Object) 
  | LET  -> (null : System.Object) 
  | AND  -> (null : System.Object) 
  | REC  -> (null : System.Object) 
  | VDASH  -> (null : System.Object) 
  | DOT  -> (null : System.Object) 
  | LP  -> (null : System.Object) 
  | RP  -> (null : System.Object) 
  | BADTOK  -> (null : System.Object) 
  | EOF  -> (null : System.Object) 
  | NUMBER _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
  | IDENT _fsyacc_x -> Microsoft.FSharp.Core.Operators.box _fsyacc_x 
let _fsyacc_gotos = [| 0us; 65535us; 1us; 65535us; 0us; 1us; 2us; 65535us; 0us; 2us; 8us; 9us; 3us; 65535us; 6us; 7us; 11us; 12us; 15us; 14us; 1us; 65535us; 3us; 4us; 11us; 65535us; 3us; 16us; 26us; 27us; 28us; 29us; 30us; 31us; 39us; 32us; 48us; 33us; 49us; 34us; 53us; 35us; 54us; 36us; 64us; 37us; 69us; 38us; 11us; 65535us; 3us; 21us; 26us; 21us; 28us; 21us; 30us; 21us; 39us; 21us; 48us; 21us; 49us; 21us; 53us; 21us; 54us; 21us; 64us; 21us; 69us; 21us; 11us; 65535us; 3us; 25us; 26us; 25us; 28us; 25us; 30us; 25us; 39us; 25us; 48us; 25us; 49us; 25us; 53us; 25us; 54us; 25us; 64us; 25us; 69us; 25us; 13us; 65535us; 3us; 23us; 26us; 23us; 28us; 23us; 30us; 23us; 39us; 23us; 48us; 23us; 49us; 23us; 53us; 23us; 54us; 23us; 55us; 60us; 57us; 60us; 64us; 23us; 69us; 23us; 13us; 65535us; 3us; 24us; 26us; 24us; 28us; 24us; 30us; 24us; 39us; 24us; 48us; 24us; 49us; 24us; 53us; 24us; 54us; 24us; 55us; 61us; 57us; 61us; 64us; 24us; 69us; 24us; 11us; 65535us; 3us; 18us; 26us; 18us; 28us; 18us; 30us; 18us; 39us; 18us; 48us; 18us; 49us; 18us; 53us; 18us; 54us; 18us; 64us; 18us; 69us; 18us; 2us; 65535us; 43us; 44us; 50us; 51us; 1us; 65535us; 45us; 46us; 11us; 65535us; 3us; 20us; 26us; 20us; 28us; 20us; 30us; 20us; 39us; 20us; 48us; 20us; 49us; 20us; 53us; 20us; 54us; 20us; 64us; 20us; 69us; 20us; 13us; 65535us; 3us; 66us; 26us; 66us; 28us; 66us; 30us; 66us; 39us; 66us; 48us; 66us; 49us; 66us; 53us; 66us; 54us; 66us; 55us; 56us; 57us; 58us; 64us; 66us; 69us; 66us; 11us; 65535us; 3us; 55us; 26us; 55us; 28us; 55us; 30us; 55us; 39us; 55us; 48us; 55us; 49us; 55us; 53us; 55us; 54us; 55us; 64us; 55us; 69us; 55us; 11us; 65535us; 3us; 19us; 26us; 19us; 28us; 19us; 30us; 19us; 39us; 19us; 48us; 19us; 49us; 19us; 53us; 19us; 54us; 19us; 64us; 19us; 69us; 19us; 5us; 65535us; 43us; 47us; 45us; 52us; 50us; 47us; 67us; 68us; 70us; 71us; 13us; 65535us; 3us; 22us; 26us; 22us; 28us; 22us; 30us; 22us; 39us; 22us; 48us; 22us; 49us; 22us; 53us; 22us; 54us; 22us; 55us; 59us; 57us; 59us; 64us; 22us; 69us; 22us; |]
let _fsyacc_sparseGotoTableRowOffsets = [|0us; 1us; 3us; 6us; 10us; 12us; 24us; 36us; 48us; 62us; 76us; 88us; 91us; 93us; 105us; 119us; 131us; 143us; 149us; |]
let _fsyacc_stateToProdIdxsTableElements = [| 1us; 0us; 1us; 0us; 1us; 1us; 1us; 1us; 1us; 1us; 2us; 3us; 4us; 2us; 3us; 4us; 3us; 3us; 4us; 7us; 1us; 4us; 1us; 4us; 1us; 5us; 1us; 6us; 2us; 6us; 7us; 1us; 6us; 2us; 7us; 7us; 1us; 7us; 2us; 8us; 18us; 1us; 8us; 1us; 9us; 1us; 10us; 2us; 11us; 36us; 1us; 12us; 2us; 13us; 29us; 2us; 14us; 30us; 2us; 15us; 31us; 1us; 16us; 1us; 17us; 2us; 17us; 18us; 1us; 17us; 2us; 17us; 18us; 1us; 17us; 2us; 17us; 18us; 2us; 18us; 18us; 3us; 18us; 24us; 25us; 2us; 18us; 24us; 2us; 18us; 26us; 2us; 18us; 26us; 2us; 18us; 34us; 2us; 18us; 37us; 1us; 18us; 1us; 19us; 1us; 20us; 1us; 21us; 2us; 22us; 23us; 1us; 22us; 1us; 23us; 1us; 23us; 2us; 24us; 25us; 2us; 24us; 25us; 1us; 24us; 1us; 25us; 1us; 25us; 1us; 26us; 1us; 26us; 1us; 26us; 2us; 27us; 28us; 1us; 27us; 1us; 28us; 1us; 28us; 1us; 29us; 1us; 30us; 1us; 31us; 1us; 32us; 1us; 33us; 1us; 34us; 1us; 34us; 1us; 35us; 1us; 37us; 1us; 37us; 1us; 37us; 2us; 38us; 39us; 1us; 39us; 1us; 40us; |]
let _fsyacc_stateToProdIdxsTableRowOffsets = [|0us; 2us; 4us; 6us; 8us; 10us; 13us; 16us; 20us; 22us; 24us; 26us; 28us; 31us; 33us; 36us; 38us; 41us; 43us; 45us; 47us; 50us; 52us; 55us; 58us; 61us; 63us; 65us; 68us; 70us; 73us; 75us; 78us; 81us; 85us; 88us; 91us; 94us; 97us; 100us; 102us; 104us; 106us; 108us; 111us; 113us; 115us; 117us; 120us; 123us; 125us; 127us; 129us; 131us; 133us; 135us; 138us; 140us; 142us; 144us; 146us; 148us; 150us; 152us; 154us; 156us; 158us; 160us; 162us; 164us; 166us; 169us; 171us; |]
let _fsyacc_action_rows = 73
let _fsyacc_actionTableElements = [|1us; 16386us; 28us; 5us; 0us; 49152us; 1us; 32768us; 21us; 3us; 10us; 32768us; 5us; 62us; 6us; 63us; 7us; 40us; 8us; 41us; 10us; 26us; 17us; 67us; 18us; 43us; 23us; 64us; 27us; 42us; 28us; 72us; 0us; 16385us; 1us; 32768us; 3us; 6us; 2us; 32768us; 23us; 11us; 28us; 10us; 2us; 16387us; 1us; 8us; 15us; 15us; 1us; 16386us; 28us; 5us; 0us; 16388us; 0us; 16389us; 2us; 32768us; 23us; 11us; 28us; 10us; 2us; 32768us; 15us; 15us; 24us; 13us; 0us; 16390us; 0us; 16391us; 2us; 32768us; 23us; 11us; 28us; 10us; 2us; 32768us; 2us; 17us; 13us; 39us; 0us; 16392us; 0us; 16393us; 0us; 16394us; 8us; 16395us; 5us; 16420us; 6us; 16420us; 7us; 16420us; 8us; 16420us; 16us; 16420us; 23us; 16420us; 27us; 16420us; 28us; 16420us; 0us; 16396us; 8us; 16397us; 5us; 16413us; 6us; 16413us; 7us; 16413us; 8us; 16413us; 16us; 16413us; 23us; 16413us; 27us; 16413us; 28us; 16413us; 8us; 16398us; 5us; 16414us; 6us; 16414us; 7us; 16414us; 8us; 16414us; 16us; 16414us; 23us; 16414us; 27us; 16414us; 28us; 16414us; 8us; 16399us; 5us; 16415us; 6us; 16415us; 7us; 16415us; 8us; 16415us; 16us; 16415us; 23us; 16415us; 27us; 16415us; 28us; 16415us; 0us; 16400us; 10us; 32768us; 5us; 62us; 6us; 63us; 7us; 40us; 8us; 41us; 10us; 26us; 17us; 67us; 18us; 43us; 23us; 64us; 27us; 42us; 28us; 72us; 2us; 32768us; 11us; 28us; 13us; 39us; 10us; 32768us; 5us; 62us; 6us; 63us; 7us; 40us; 8us; 41us; 10us; 26us; 17us; 67us; 18us; 43us; 23us; 64us; 27us; 42us; 28us; 72us; 2us; 32768us; 12us; 30us; 13us; 39us; 10us; 32768us; 5us; 62us; 6us; 63us; 7us; 40us; 8us; 41us; 10us; 26us; 17us; 67us; 18us; 43us; 23us; 64us; 27us; 42us; 28us; 72us; 1us; 16401us; 13us; 39us; 0us; 16402us; 3us; 32768us; 13us; 39us; 14us; 49us; 19us; 50us; 1us; 16408us; 13us; 39us; 2us; 32768us; 13us; 39us; 14us; 54us; 1us; 16410us; 13us; 39us; 2us; 32768us; 13us; 39us; 24us; 65us; 1us; 16421us; 13us; 39us; 10us; 32768us; 5us; 62us; 6us; 63us; 7us; 40us; 8us; 41us; 10us; 26us; 17us; 67us; 18us; 43us; 23us; 64us; 27us; 42us; 28us; 72us; 0us; 16403us; 0us; 16404us; 0us; 16405us; 2us; 32768us; 20us; 45us; 28us; 70us; 0us; 16406us; 1us; 32768us; 28us; 70us; 0us; 16407us; 1us; 32768us; 13us; 48us; 10us; 32768us; 5us; 62us; 6us; 63us; 7us; 40us; 8us; 41us; 10us; 26us; 17us; 67us; 18us; 43us; 23us; 64us; 27us; 42us; 28us; 72us; 10us; 32768us; 5us; 62us; 6us; 63us; 7us; 40us; 8us; 41us; 10us; 26us; 17us; 67us; 18us; 43us; 23us; 64us; 27us; 42us; 28us; 72us; 1us; 32768us; 28us; 70us; 0us; 16409us; 1us; 32768us; 13us; 53us; 10us; 32768us; 5us; 62us; 6us; 63us; 7us; 40us; 8us; 41us; 10us; 26us; 17us; 67us; 18us; 43us; 23us; 64us; 27us; 42us; 28us; 72us; 10us; 32768us; 5us; 62us; 6us; 63us; 7us; 40us; 8us; 41us; 10us; 26us; 17us; 67us; 18us; 43us; 23us; 64us; 27us; 42us; 28us; 72us; 8us; 32768us; 5us; 62us; 6us; 63us; 7us; 40us; 8us; 41us; 16us; 57us; 23us; 64us; 27us; 42us; 28us; 72us; 0us; 16411us; 7us; 32768us; 5us; 62us; 6us; 63us; 7us; 40us; 8us; 41us; 23us; 64us; 27us; 42us; 28us; 72us; 0us; 16412us; 0us; 16413us; 0us; 16414us; 0us; 16415us; 0us; 16416us; 0us; 16417us; 10us; 32768us; 5us; 62us; 6us; 63us; 7us; 40us; 8us; 41us; 10us; 26us; 17us; 67us; 18us; 43us; 23us; 64us; 27us; 42us; 28us; 72us; 0us; 16418us; 0us; 16419us; 1us; 32768us; 28us; 70us; 1us; 32768us; 15us; 69us; 10us; 32768us; 5us; 62us; 6us; 63us; 7us; 40us; 8us; 41us; 10us; 26us; 17us; 67us; 18us; 43us; 23us; 64us; 27us; 42us; 28us; 72us; 1us; 16422us; 28us; 70us; 0us; 16423us; 0us; 16424us; |]
let _fsyacc_actionTableRowOffsets = [|0us; 2us; 3us; 5us; 16us; 17us; 19us; 22us; 25us; 27us; 28us; 29us; 32us; 35us; 36us; 37us; 40us; 43us; 44us; 45us; 46us; 55us; 56us; 65us; 74us; 83us; 84us; 95us; 98us; 109us; 112us; 123us; 125us; 126us; 130us; 132us; 135us; 137us; 140us; 142us; 153us; 154us; 155us; 156us; 159us; 160us; 162us; 163us; 165us; 176us; 187us; 189us; 190us; 192us; 203us; 214us; 223us; 224us; 232us; 233us; 234us; 235us; 236us; 237us; 238us; 249us; 250us; 251us; 253us; 255us; 266us; 268us; 269us; |]
let _fsyacc_reductionSymbolCounts = [|1us; 3us; 0us; 3us; 5us; 1us; 3us; 3us; 2us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 1us; 6us; 3us; 1us; 1us; 1us; 2us; 3us; 5us; 5us; 5us; 2us; 3us; 1us; 1us; 1us; 1us; 1us; 3us; 1us; 1us; 4us; 1us; 2us; 1us; |]
let _fsyacc_productionToNonTerminalTable = [|0us; 1us; 2us; 2us; 2us; 3us; 3us; 3us; 4us; 5us; 5us; 5us; 5us; 5us; 5us; 5us; 5us; 6us; 7us; 8us; 8us; 9us; 10us; 10us; 11us; 11us; 12us; 13us; 13us; 14us; 14us; 14us; 14us; 14us; 14us; 15us; 15us; 16us; 17us; 17us; 18us; |]
let _fsyacc_immediateActions = [|65535us; 49152us; 65535us; 65535us; 16385us; 65535us; 65535us; 65535us; 65535us; 16388us; 16389us; 65535us; 65535us; 16390us; 65535us; 65535us; 65535us; 16392us; 16393us; 16394us; 65535us; 16396us; 65535us; 65535us; 65535us; 16400us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 65535us; 16403us; 16404us; 16405us; 65535us; 16406us; 65535us; 16407us; 65535us; 65535us; 65535us; 65535us; 16409us; 65535us; 65535us; 65535us; 65535us; 16411us; 65535us; 16412us; 16413us; 16414us; 16415us; 16416us; 16417us; 65535us; 16418us; 16419us; 65535us; 65535us; 65535us; 65535us; 16423us; 16424us; |]
let _fsyacc_reductions ()  =    [| 
# 292 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Coreml.ml_termincontext)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
                      raise (Microsoft.FSharp.Text.Parsing.Accept(Microsoft.FSharp.Core.Operators.box _1))
                   )
                 : '_startterm_in_context));
# 301 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : Coreml.ml_context)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : Coreml.ml_expr)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 40 "ml_parser.mly"
                     _1,_3
                   )
# 40 "ml_parser.mly"
                 : Coreml.ml_termincontext));
# 313 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 42 "ml_parser.mly"
                      [] 
                   )
# 42 "ml_parser.mly"
                 : Coreml.ml_context));
# 323 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typ)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 43 "ml_parser.mly"
                      [_1,_3] 
                   )
# 43 "ml_parser.mly"
                 : Coreml.ml_context));
# 335 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typ)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : Coreml.ml_context)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 44 "ml_parser.mly"
                      (_1,_3)::_5 
                   )
# 44 "ml_parser.mly"
                 : Coreml.ml_context));
# 348 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 49 "ml_parser.mly"
                      if _1 = "o" then PTypGr else failwith "Invalid type!" 
                   )
# 49 "ml_parser.mly"
                 : 'typ));
# 359 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'typ)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 50 "ml_parser.mly"
                      _2 
                   )
# 50 "ml_parser.mly"
                 : 'typ));
# 370 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'typ)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'typ)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 51 "ml_parser.mly"
                      PTypAr(_1,_3) 
                   )
# 51 "ml_parser.mly"
                 : 'typ));
# 382 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'expression)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 57 "ml_parser.mly"
                     _1
                   )
# 57 "ml_parser.mly"
                 : Coreml.ml_expr));
# 393 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'declaration)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 60 "ml_parser.mly"
                     _1
                   )
# 60 "ml_parser.mly"
                 : 'expression));
# 404 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'abstraction)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 61 "ml_parser.mly"
                     _1
                   )
# 61 "ml_parser.mly"
                 : 'expression));
# 415 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'application)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 62 "ml_parser.mly"
                     _1
                   )
# 62 "ml_parser.mly"
                 : 'expression));
# 426 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ifthenelse)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 63 "ml_parser.mly"
                     _1
                   )
# 63 "ml_parser.mly"
                 : 'expression));
# 437 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'variable)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 64 "ml_parser.mly"
                     _1
                   )
# 64 "ml_parser.mly"
                 : 'expression));
# 448 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'boolean)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 65 "ml_parser.mly"
                     Coreml.MlBool(_1)
                   )
# 65 "ml_parser.mly"
                 : 'expression));
# 459 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'integer)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 66 "ml_parser.mly"
                     Coreml.MlInt(_1)
                   )
# 66 "ml_parser.mly"
                 : 'expression));
# 470 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'condition)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 67 "ml_parser.mly"
                     _1
                   )
# 67 "ml_parser.mly"
                 : 'expression));
# 481 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'expression)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'expression)) in
            let _6 = (let data = parseState.GetInput(6) in (Microsoft.FSharp.Core.Operators.unbox data : 'expression)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 70 "ml_parser.mly"
                      Coreml.If(_2,_4,_6) 
                   )
# 70 "ml_parser.mly"
                 : 'ifthenelse));
# 494 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'expression)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'expression)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 73 "ml_parser.mly"
                      Coreml.EqTest(_1,_3) 
                   )
# 73 "ml_parser.mly"
                 : 'condition));
# 506 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 77 "ml_parser.mly"
                      true 
                   )
# 77 "ml_parser.mly"
                 : 'boolean));
# 516 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 78 "ml_parser.mly"
                      false 
                   )
# 78 "ml_parser.mly"
                 : 'boolean));
# 526 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : int)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 81 "ml_parser.mly"
                      _1 
                   )
# 81 "ml_parser.mly"
                 : 'integer));
# 537 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'decl_list_next)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 84 "ml_parser.mly"
                     _2
                   )
# 84 "ml_parser.mly"
                 : 'declaration));
# 548 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'recdecl_list_next)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 85 "ml_parser.mly"
                     _3
                   )
# 85 "ml_parser.mly"
                 : 'declaration));
# 559 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident_list)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'expression)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'expression)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 88 "ml_parser.mly"
                      Coreml.Let([List.hd _1, List.tl _1,_3],_5) 
                   )
# 88 "ml_parser.mly"
                 : 'decl_list_next));
# 572 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident_list)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'expression)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'decl_list_next)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 89 "ml_parser.mly"
                      match _5 with
                     								                                      Coreml.Let(decl,inexp) ->
                     									                                    Coreml.Let(((List.hd _1, List.tl _1,_3)::decl),inexp)
                     								                                    |  _ -> failwith "bug in parser!" 
                   )
# 89 "ml_parser.mly"
                 : 'decl_list_next));
# 588 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident_list)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'expression)) in
            let _5 = (let data = parseState.GetInput(5) in (Microsoft.FSharp.Core.Operators.unbox data : 'expression)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 95 "ml_parser.mly"
                      Coreml.Letrec([List.hd _1, List.tl _1,_3],_5) 
                   )
# 95 "ml_parser.mly"
                 : 'recdecl_list_next));
# 601 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'operator)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'operand)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 104 "ml_parser.mly"
                      Coreml.MlAppl(_1,_2) 
                   )
# 104 "ml_parser.mly"
                 : 'application));
# 613 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'operator)) in
            let _3 = (let data = parseState.GetInput(3) in (Microsoft.FSharp.Core.Operators.unbox data : 'operand)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 105 "ml_parser.mly"
                      Coreml.MlAppl(_1,_3) 
                   )
# 105 "ml_parser.mly"
                 : 'application));
# 625 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'variable)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 108 "ml_parser.mly"
                      _1 
                   )
# 108 "ml_parser.mly"
                 : 'operand));
# 636 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'boolean)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 109 "ml_parser.mly"
                      Coreml.MlBool(_1) 
                   )
# 109 "ml_parser.mly"
                 : 'operand));
# 647 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'integer)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 110 "ml_parser.mly"
                      Coreml.MlInt(_1) 
                   )
# 110 "ml_parser.mly"
                 : 'operand));
# 658 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 111 "ml_parser.mly"
                      Coreml.Succ 
                   )
# 111 "ml_parser.mly"
                 : 'operand));
# 668 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 112 "ml_parser.mly"
                      Coreml.Pred 
                   )
# 112 "ml_parser.mly"
                 : 'operand));
# 678 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'expression)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 113 "ml_parser.mly"
                      _2 
                   )
# 113 "ml_parser.mly"
                 : 'operand));
# 689 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'operand)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 116 "ml_parser.mly"
                      _1 
                   )
# 116 "ml_parser.mly"
                 : 'operator));
# 700 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : 'application)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 117 "ml_parser.mly"
                      _1 
                   )
# 117 "ml_parser.mly"
                 : 'operator));
# 711 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident_list)) in
            let _4 = (let data = parseState.GetInput(4) in (Microsoft.FSharp.Core.Operators.unbox data : 'expression)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 120 "ml_parser.mly"
                      List.fold_right (fun x e -> Coreml.Fun(x,e)) _2 _4 
                   )
# 120 "ml_parser.mly"
                 : 'abstraction));
# 723 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 123 "ml_parser.mly"
                      [_1] 
                   )
# 123 "ml_parser.mly"
                 : 'ident_list));
# 734 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            let _2 = (let data = parseState.GetInput(2) in (Microsoft.FSharp.Core.Operators.unbox data : 'ident_list)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 124 "ml_parser.mly"
                      _1::_2
                   )
# 124 "ml_parser.mly"
                 : 'ident_list));
# 746 "ml_parser.ml"
        (fun (parseState : Microsoft.FSharp.Text.Parsing.IParseState) ->
            let _1 = (let data = parseState.GetInput(1) in (Microsoft.FSharp.Core.Operators.unbox data : string)) in
            Microsoft.FSharp.Core.Operators.box
                (
                   (
# 127 "ml_parser.mly"
                      Coreml.MlVar(_1) 
                   )
# 127 "ml_parser.mly"
                 : 'variable));
|]
# 758 "ml_parser.ml"
let tables () : Microsoft.FSharp.Text.Parsing.Tables<_> = 
  { reductions= _fsyacc_reductions ();
    endOfInputTag = _fsyacc_endOfInputTag;
    tagOfToken = tagOfToken;
    dataOfToken = _fsyacc_dataOfToken; 
    actionTableElements = _fsyacc_actionTableElements;
    actionTableRowOffsets = _fsyacc_actionTableRowOffsets;
    stateToProdIdxsTableElements = _fsyacc_stateToProdIdxsTableElements;
    stateToProdIdxsTableRowOffsets = _fsyacc_stateToProdIdxsTableRowOffsets;
    reductionSymbolCounts = _fsyacc_reductionSymbolCounts;
    immediateActions = _fsyacc_immediateActions;
    gotos = _fsyacc_gotos;
    sparseGotoTableRowOffsets = _fsyacc_sparseGotoTableRowOffsets;
    tagOfErrorTerminal = _fsyacc_tagOfErrorTerminal;
    parseError = (fun (ctxt:Microsoft.FSharp.Text.Parsing.ParseErrorContext<_>) -> 
                              match parse_error_rich with 
                              | Some f -> f ctxt
                              | None -> parse_error ctxt.Message);
    numTerminals = 32;
    productionToNonTerminalTable = _fsyacc_productionToNonTerminalTable  }
let engine lexer lexbuf startState = (tables ()).Interpret(lexer, lexbuf, startState)
let term_in_context lexer lexbuf : Coreml.ml_termincontext =
    Microsoft.FSharp.Core.Operators.unbox ((tables ()).Interpret(lexer, lexbuf, 0))
